namespace DreamsCaster.Helpers;

public struct Optional<T>
{
	private T _value = default(T);

	public bool HasValue { get; private set; }

	public T Value
	{
		get => _value;
		set
		{
			_value = value;
			HasValue = true;
		}
	}

	public Optional()
	{
		HasValue = false;
	}

	public Optional(bool hasValue, T value) : this()
	{
		HasValue = hasValue;
		_value = value;
	}

	public static implicit operator T(Optional<T> d) => d.HasValue ? d.Value : default;
}